<?php
	function lee_relacion($archivo)
	{
		$filas = file($archivo, FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES);
		$header = str_getcsv($filas[0]);
		$cuerpo = [ ];
		
		if ($header != array_unique($header)) {
			die("$archivo: atributos repetidos");
		}
		
		for ($i = 1; $i < count($filas); ++$i) {
			$cuerpo[] = array_combine($header, str_getcsv($filas[$i]));
		}
		
		return [ 
			'header' => $header, 
			'cuerpo' => $cuerpo
		];
	}
	
	$materia = lee_relacion('materia.csv');
	$kardex = lee_relacion('kardex.csv');
	
	$conexion = new mysqli('localhost', 'root', '', 'ejemplo');
	$conexion->query('TRUNCATE materia');
	$conexion->query('TRUNCATE kardex');
	
	// insertar las tuplas en la base de cuenta
	foreach ($materia['cuerpo'] as $tupla) {
		$clave = $tupla['clave'];
		$nombre = $conexion->escape_string($tupla['nombre']);
		
		$conexion->query("INSERT INTO materia (clave, nombre) VALUES ($clave, '$nombre')");
	}
	
	foreach ($kardex['cuerpo'] as $tupla) {
		$clave = $tupla['clave'];
		$matricula = $tupla['matricula'];
		$calificacion = $tupla['calificacion'];
		
		$conexion->query("INSERT INTO kardex (clave, matricula, calificacion) VALUES ($clave, $matricula, $calificacion)");
	}

	// subirle un punto a las entradas con calificación 8 o 9
	$conexion->query('UPDATE kardex SET calificacion = 10 WHERE calificacion = 9');
	$conexion->query('UPDATE kardex SET calificacion = 9 WHERE calificacion = 8');
	
	// eliminar todos los registros de los alumnos que tienen algún 0 en alguna materia
	$res1 = $conexion->query('SELECT matricula FROM kardex WHERE calificacion = 0');
	$arr1 = $res1->fetch_all(MYSQLI_ASSOC);
	
	foreach ($arr1 as $tupla) {
		$matricula = $tupla['matricula'];
		$conexion->query("DELETE FROM kardex WHERE matricula = $matricula");
	}
	
	// eliminar todas las materias en donde hay más reprobados que aprobados (preprocesamiento se comparte con el siguiente inciso)
	$res2 = $conexion->query('SELECT clave, calificacion FROM kardex');
	$arr2 = $res2->fetch_all(MYSQLI_ASSOC);
	$cuentas = [ ];
	
	foreach ($arr2 as $tupla) {
		$cuentas[$tupla['clave']] = [
			'aprobados' => 0,
			'reprobados' => 0,
			'con_diez' => 0
		];
	}
	
	foreach ($arr2 as $tupla) {
		$clave = $tupla['clave'];
		$calificacion = $tupla['calificacion'];
		
		$cuentas[$clave]['aprobados'] += ($calificacion >= 6);	// una manera de hacerlo sin
		$cuentas[$clave]['reprobados'] += ($calificacion < 6);	// usar el if (el if está bien)
		$cuentas[$clave]['con_diez'] += ($calificacion == 10);
	}
	
	foreach ($cuentas as $clave => $cuenta) {
		if ($cuenta['reprobados'] > $cuenta['aprobados']) {
			$conexion->query("DELETE FROM materia WHERE clave = $clave");
			$conexion->query("DELETE FROM kardex WHERE clave = $clave");
		}
	}
	
	// poner un ' al inicio del nombre de las materias donde todos sacaron 10 (preprocesamiento se comparte con el anterior inciso)
	foreach ($cuentas as $clave => $cuenta) {
		if ($cuenta['con_diez'] > 0 && $cuenta['con_diez'] == $cuenta['aprobados'] + $cuenta['reprobados']) {
			$res3 = $conexion->query("SELECT nombre FROM materia WHERE clave = $clave");
			$arr3 = $res3->fetch_all(MYSQLI_ASSOC);
			$nombre = $conexion->escape_string($arr3[0]['nombre']);

			$conexion->query("UPDATE materia SET nombre = '\\'$nombre' WHERE clave = $clave");
		}
	}
?>